﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            axTChart1.Tools.Active = true;
        }

        List<TeeChart.ITools> loadedTools = new List<TeeChart.ITools>();

        Random rnd = new Random((int)Environment.TickCount);

        private void button1_Click(object sender, EventArgs e)
        {
            int value = rnd.Next(10, 490);

            int index = axTChart1.Tools.Add(TeeChart.EToolClass.tcColorLine);

            TeeChart.ITools tool = (TeeChart.ITools)axTChart1.Tools[index];
            
            TeeChart.IColorLineTool colorLine = tool.asColorLine;

            colorLine.Value = value;
            colorLine.Axis = axTChart1.Axis.Left;
            colorLine.AllowDrag = false;
            colorLine.DrawBehind = false;
            colorLine.Style = TeeChart.EColorLineStyle.clCustom;
            colorLine.Pen.Width = 2;

            tool.Active = true;

            loadedTools.Add(tool);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            // here I randomly select a tool to be removed, but in a actual application, the user will choose the one to be removed
            int index = rnd.Next(0, loadedTools.Count);

            TeeChart.ITools toolToRemove = loadedTools[index]; 

            // now find the index of toolToRemove and delete from chart
            for (int i=0; i < axTChart1.Tools.Count; i++)
            {
                if (axTChart1.Tools[i] == toolToRemove) // BUG: this will NEVER be equal
                {
                    axTChart1.Tools.Delete(i); // BUG: this will NEVER be executed
                    break;
                }
            }
        }
    }
}